VTK: vtkDataSetAttributes Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends | List of all members
vtkDataSetAttributes Class Reference

represent and manipulate attribute data in a dataset More...

`#include <vtkDataSetAttributes.h>`

Inheritance diagram for vtkDataSetAttributes:
[legend]
Collaboration diagram for vtkDataSetAttributes:
[legend]

## Public Types
enum | AttributeTypes { SCALARS = 0 , VECTORS = 1 , NORMALS = 2 , TCOORDS = 3 , TENSORS = 4 , GLOBALIDS = 5 , PEDIGREEIDS = 6 , EDGEFLAG = 7 , TANGENTS = 8 , RATIONALWEIGHTS = 9 , HIGHERORDERDEGREES = 10 , PROCESSIDS = 11 , NUM_ATTRIBUTES }
enum | AttributeLimitTypes { MAX , EXACT , NOLIMIT }
enum | CellGhostTypes { DUPLICATECELL = 1 , HIGHCONNECTIVITYCELL = 2 , LOWCONNECTIVITYCELL = 4 , REFINEDCELL = 8 , EXTERIORCELL = 16 , HIDDENCELL }
enum | PointGhostTypes { DUPLICATEPOINT = 1 , HIDDENPOINT }
enum | AttributeCopyOperations { COPYTUPLE = 0 , INTERPOLATE = 1 , PASSDATA = 2 , ALLCOPY }
typedef vtkFieldData | Superclass
using | FieldList = vtkDataSetAttributesFieldList
Public Types inherited from vtkFieldData
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDataSetAttributes * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Initialize () override
| Initialize all of the object's data to nullptr Also, clear the copy flags. More...
virtual void | Update ()
| Attributes have a chance to bring themselves up to date; right now this is ignored. More...
void | DeepCopy (vtkFieldData *pd) override
| Deep copy of data (i.e., create new data arrays and copy from input data). More...
void | ShallowCopy (vtkFieldData *pd) override
| Shallow copy of data (i.e., use reference counting). More...
int | SetActiveAttribute (const char *name, int attributeType)
| Make the array with the given name the active attribute. More...
int | SetActiveAttribute (int index, int attributeType)
| Make the array with the given index the active attribute. More...
void | GetAttributeIndices (int *indexArray)
| Get the field data array indices corresponding to scalars, vectors, tensors, etc. More...
int | IsArrayAnAttribute (int idx)
| Determine whether a data array of index idx is considered a data set attribute (i.e., scalar, vector, tensor, etc). More...
int | SetAttribute (vtkAbstractArray *aa, int attributeType)
| Set an array to use as the given attribute type (i.e., vtkDataSetAttributes::SCALAR, vtkDataSetAttributes::VECTOR, vtkDataSetAttributes::TENSOR, etc.). More...
vtkDataArray * | GetAttribute (int attributeType)
| Return an attribute given the attribute type (see vtkDataSetAttributes::AttributeTypes). More...
vtkAbstractArray * | GetAbstractAttribute (int attributeType)
| Return an attribute given the attribute type (see vtkDataSetAttributes::AttributeTypes). More...
void | SetCopyAttribute (int index, int value, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
int | GetCopyAttribute (int index, int ctype)
| Get the attribute copy flag for copy operation `ctype` of attribute `index`. More...
void | SetCopyScalars (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyScalars (int ctype=ALLCOPY)
virtual void | CopyScalarsOn ()
virtual void | CopyScalarsOff ()
void | SetCopyVectors (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyVectors (int ctype=ALLCOPY)
virtual void | CopyVectorsOn ()
virtual void | CopyVectorsOff ()
void | SetCopyNormals (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyNormals (int ctype=ALLCOPY)
virtual void | CopyNormalsOn ()
virtual void | CopyNormalsOff ()
void | SetCopyTangents (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyTangents (int ctype=ALLCOPY)
virtual void | CopyTangentsOn ()
virtual void | CopyTangentsOff ()
void | SetCopyTCoords (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyTCoords (int ctype=ALLCOPY)
virtual void | CopyTCoordsOn ()
virtual void | CopyTCoordsOff ()
void | SetCopyTensors (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyTensors (int ctype=ALLCOPY)
virtual void | CopyTensorsOn ()
virtual void | CopyTensorsOff ()
void | SetCopyGlobalIds (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyGlobalIds (int ctype=ALLCOPY)
virtual void | CopyGlobalIdsOn ()
virtual void | CopyGlobalIdsOff ()
void | SetCopyPedigreeIds (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyPedigreeIds (int ctype=ALLCOPY)
virtual void | CopyPedigreeIdsOn ()
virtual void | CopyPedigreeIdsOff ()
void | SetCopyRationalWeights (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyRationalWeights (int ctype=ALLCOPY)
virtual void | CopyRationalWeightsOn ()
virtual void | CopyRationalWeightsOff ()
void | SetCopyHigherOrderDegrees (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyHigherOrderDegrees (int ctype=ALLCOPY)
virtual void | CopyHigherOrderDegreesOn ()
virtual void | CopyHigherOrderDegreesOff ()
void | SetCopyProcessIds (vtkTypeBool i, int ctype=ALLCOPY)
| Turn on/off the copying of attribute data. More...
vtkTypeBool | GetCopyProcessIds (int ctype=ALLCOPY)
virtual void | CopyProcessIdsOn ()
virtual void | CopyProcessIdsOff ()
void | CopyAllOn (int ctype=ALLCOPY) override
| Turn on/off the copying of attribute data. More...
void | CopyAllOff (int ctype=ALLCOPY) override
| Turn on/off the copying of attribute data. More...
void | PassData (vtkFieldData *fd) override
| Pass entire arrays of input data through to output. More...
void | SetupForCopy (vtkDataSetAttributes *pd)
| Create a mapping between the input attributes and this object so that methods like CopyData() and CopyStructuredData() can be called. More...
void | CopyStructuredData (vtkDataSetAttributes *inDsa, const int *inExt, const int *outExt, bool setSize=true)
| This method is used to copy data arrays in images. More...
void | CopyData (vtkDataSetAttributes *fromPd, vtkIdType dstStart, vtkIdType n, vtkIdType srcStart)
| Copy n consecutive attributes starting at srcStart from fromPd to this container, starting at the dstStart location. More...
void | InterpolatePoint (vtkDataSetAttributes *fromPd, vtkIdType toId, vtkIdList *ids, double *weights)
| Interpolate data set attributes from other data set attributes given cell or point ids and associated interpolation weights. More...
void | InterpolateEdge (vtkDataSetAttributes *fromPd, vtkIdType toId, vtkIdType p1, vtkIdType p2, double t)
| Interpolate data from the two points p1,p2 (forming an edge) and an interpolation factor, t, along the edge. More...
void | InterpolateTime (vtkDataSetAttributes *from1, vtkDataSetAttributes *from2, vtkIdType id, double t)
| Interpolate data from the same id (point or cell) at different points in time (parameter t). More...
void | CopyAllocate (vtkDataSetAttributes::FieldList &list, vtkIdType sze=0, vtkIdType ext=1000)
| A special form of CopyAllocate() to be used with FieldLists. More...
void | CopyData (vtkDataSetAttributes::FieldList &list, vtkDataSetAttributes *dsa, int idx, vtkIdType fromId, vtkIdType toId)
| Special forms of CopyData() to be used with FieldLists. More...
void | CopyData (vtkDataSetAttributes::FieldList &list, vtkDataSetAttributes *dsa, int idx, vtkIdType dstStart, vtkIdType n, vtkIdType srcStart)
void | InterpolateAllocate (vtkDataSetAttributes::FieldList &list, vtkIdType sze=0, vtkIdType ext=1000)
| A special form of InterpolateAllocate() to be used with FieldLists. More...
void | InterpolatePoint (vtkDataSetAttributes::FieldList &list, vtkDataSetAttributes *fromPd, int idx, vtkIdType toId, vtkIdList *ids, double *weights)
| Interpolate data set attributes from other data set attributes given cell or point ids and associated interpolation weights. More...
int | SetScalars (vtkDataArray *da)
| Set/Get the scalar data. More...
int | SetActiveScalars (const char *name)
| Set/Get the scalar data. More...
vtkDataArray * | GetScalars ()
| Set/Get the scalar data. More...
int | SetVectors (vtkDataArray *da)
| Set/Get the vector data. More...
int | SetActiveVectors (const char *name)
| Set/Get the vector data. More...
vtkDataArray * | GetVectors ()
| Set/Get the vector data. More...
int | SetNormals (vtkDataArray *da)
| Set/get the normal data. More...
int | SetActiveNormals (const char *name)
| Set/get the normal data. More...
vtkDataArray * | GetNormals ()
| Set/get the normal data. More...
int | SetTangents (vtkDataArray *da)
| Set/get the tangent data. More...
int | SetActiveTangents (const char *name)
| Set/get the tangent data. More...
vtkDataArray * | GetTangents ()
| Set/get the tangent data. More...
int | SetTCoords (vtkDataArray *da)
| Set/Get the texture coordinate data. More...
int | SetActiveTCoords (const char *name)
| Set/Get the texture coordinate data. More...
vtkDataArray * | GetTCoords ()
| Set/Get the texture coordinate data. More...
int | SetTensors (vtkDataArray *da)
| Set/Get the tensor data. More...
int | SetActiveTensors (const char *name)
| Set/Get the tensor data. More...
vtkDataArray * | GetTensors ()
| Set/Get the tensor data. More...
int | SetGlobalIds (vtkDataArray *da)
| Set/Get the global id data. More...
int | SetActiveGlobalIds (const char *name)
| Set/Get the global id data. More...
vtkDataArray * | GetGlobalIds ()
| Set/Get the global id data. More...
int | SetPedigreeIds (vtkAbstractArray *da)
| Set/Get the pedigree id data. More...
int | SetActivePedigreeIds (const char *name)
| Set/Get the pedigree id data. More...
vtkAbstractArray * | GetPedigreeIds ()
| Set/Get the pedigree id data. More...
int | SetRationalWeights (vtkDataArray *da)
| Set/Get the rational weights data. More...
int | SetActiveRationalWeights (const char *name)
| Set/Get the rational weights data. More...
vtkDataArray * | GetRationalWeights ()
| Set/Get the rational weights data. More...
int | SetHigherOrderDegrees (vtkDataArray *da)
| Set/Get the rational degrees data. More...
int | SetActiveHigherOrderDegrees (const char *name)
| Set/Get the rational degrees data. More...
vtkDataArray * | GetHigherOrderDegrees ()
| Set/Get the rational degrees data. More...
int | SetProcessIds (vtkDataArray *da)
| Set/Get the process id data. More...
int | SetActiveProcessIds (const char *name)
| Set/Get the process id data. More...
vtkDataArray * | GetProcessIds ()
| Set/Get the process id data. More...
vtkDataArray * | GetScalars (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetVectors (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetNormals (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetTangents (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetTCoords (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetTensors (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetGlobalIds (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkAbstractArray * | GetPedigreeIds (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetRationalWeights (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetHigherOrderDegrees (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
vtkDataArray * | GetProcessIds (const char *name)
| If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters). More...
void | RemoveArray (int index) override
| Remove an array (with the given index) from the list of arrays. More...
virtual void | RemoveArray (const char *name)
| Remove an array (with the given index) from the list of arrays. More...
virtual void | RemoveArray (int index)
| Remove an array (with the given index) from the list of arrays. More...
void | CopyAllocate (vtkDataSetAttributes *pd, vtkIdType sze=0, vtkIdType ext=1000)
| Allocates point data for point-by-point (or cell-by-cell) copy operation. More...
void | CopyAllocate (vtkDataSetAttributes *pd, vtkIdType sze, vtkIdType ext, int shallowCopyArrays)
| Allocates point data for point-by-point (or cell-by-cell) copy operation. More...
void | CopyData (vtkDataSetAttributes *fromPd, vtkIdType fromId, vtkIdType toId)
| Copy the attribute data from one id to another. More...
void | CopyData (vtkDataSetAttributes *fromPd, vtkIdList *fromIds, vtkIdList *toIds)
| Copy the attribute data from one id to another. More...
void | CopyData (vtkDataSetAttributes *fromPd, vtkIdList *fromIds, vtkIdType destStartId=0)
| Copy the attribute data from one id to another. More...
void | CopyTuple (vtkAbstractArray *fromData, vtkAbstractArray *toData, vtkIdType fromId, vtkIdType toId)
| Copy a tuple (or set of tuples) of data from one data array to another. More...
void | CopyTuples (vtkAbstractArray *fromData, vtkAbstractArray *toData, vtkIdList *fromIds, vtkIdList *toIds)
| Copy a tuple (or set of tuples) of data from one data array to another. More...
void | CopyTuples (vtkAbstractArray *fromData, vtkAbstractArray *toData, vtkIdType dstStart, vtkIdType n, vtkIdType srcStart)
| Copy a tuple (or set of tuples) of data from one data array to another. More...
void | InterpolateAllocate (vtkDataSetAttributes *pd, vtkIdType sze=0, vtkIdType ext=1000)
| Initialize point interpolation method. More...
void | InterpolateAllocate (vtkDataSetAttributes *pd, vtkIdType sze, vtkIdType ext, int shallowCopyArrays)
| Initialize point interpolation method. More...
Public Member Functions inherited from vtkFieldData
vtkFieldData * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkTypeBool | Allocate (vtkIdType sz, vtkIdType ext=1000)
| Allocate data for each array. More...
void | CopyStructure (vtkFieldData *)
| Copy data array structure from a given field. More...
void | AllocateArrays (int num)
| AllocateArrays actually sets the number of vtkAbstractArray pointers in the vtkFieldData object, not the number of used pointers (arrays). More...
int | GetNumberOfArrays ()
| Get the number of arrays of data available. More...
int | AddArray (vtkAbstractArray *array)
| Add an array to the array list. More...
void | NullData (vtkIdType id)
| Sets every vtkDataArray at index id to a null tuple. More...
vtkDataArray * | GetArray (int i)
| Not recommended for use. More...
vtkDataArray * | GetArray (const char *arrayName, int &index)
| Not recommended for use. More...
vtkAbstractArray * | GetAbstractArray (int i)
| Returns the ith array in the field. More...
vtkAbstractArray * | GetAbstractArray (const char *arrayName, int &index)
| Return the array with the name given. More...
void | CopyFieldOn (const char *name)
| Turn on/off the copying of the field specified by name. More...
void | CopyFieldOff (const char *name)
void | Squeeze ()
| Squeezes each data array in the field (Squeeze() reclaims unused memory.) More...
void | Reset ()
| Resets each data array in the field (Reset() does not release memory but it makes the arrays look like they are empty.) More...
virtual unsigned long | GetActualMemorySize ()
| Return the memory in kibibytes (1024 bytes) consumed by this field data. More...
vtkMTimeType | GetMTime () override
| Check object's components for modified times. More...
void | GetField (vtkIdList *ptId, vtkFieldData *f)
| Get a field from a list of ids. More...
int | GetArrayContainingComponent (int i, int &arrayComp)
| Return the array containing the ith component of the field. More...
int | GetNumberOfComponents ()
| Get the number of components in the field. More...
vtkIdType | GetNumberOfTuples ()
| Get the number of tuples in the field. More...
void | SetNumberOfTuples (vtkIdType number)
| Set the number of tuples for each data array in the field. More...
void | SetTuple (vtkIdType i, vtkIdType j, vtkFieldData *source)
| Set the jth tuple in source field data at the ith location. More...
void | InsertTuple (vtkIdType i, vtkIdType j, vtkFieldData *source)
| Insert the jth tuple in source field data at the ith location. More...
vtkIdType | InsertNextTuple (vtkIdType j, vtkFieldData *source)
| Insert the jth tuple in source field data at the end of the tuple matrix. More...
bool | HasAnyGhostBitSet (int bitFlag)
| Helper function that tests if any of the values in ghost array has been set. More...
virtual vtkUnsignedCharArray * | GetGhostArray ()
| Get the ghost array, if present in this field data. More...
virtual void | RemoveArray (const char *name)
| Remove an array (with the given name) from the list of arrays. More...
vtkDataArray * | GetArray (const char *arrayName)
| Not recommended for use. More...
vtkAbstractArray * | GetAbstractArray (const char *arrayName)
| Return the array with the name given. More...
vtkTypeBool | HasArray (const char *name)
| Return 1 if an array with the given name could be found. More...
const char * | GetArrayName (int i)
| Get the name of ith array. More...
bool | GetRange (const char *name, double range[2], int comp=0)
| Computes the range of the input data array (specified through its `name` or the `index` in this field data). More...
bool | GetRange (int index, double range[2], int comp=0)
| Computes the range of the input data array (specified through its `name` or the `index` in this field data). More...
bool | GetFiniteRange (const char *name, double range[2], int comp=0)
| Computes the range of the input data array (specified through its `name` or the `index` in this field data). More...
bool | GetFiniteRange (int index, double range[2], int comp=0)
| Computes the range of the input data array (specified through its `name` or the `index` in this field data). More...
virtual unsigned char | GetGhostsToSkip ()
| Set / Get the binary mask filtering out certain types of ghosts when calling `GetRange`. More...
virtual void | SetGhostsToSkip (unsigned char)
| Set / Get the binary mask filtering out certain types of ghosts when calling `GetRange`. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkDataSetAttributes * | New ()
| Construct object with copying turned on for all data. More...
static vtkDataSetAttributes * | ExtendedNew ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataSetAttributes * | SafeDownCast (vtkObjectBase *o)
static const char * | GhostArrayName ()
static const char * | GetAttributeTypeAsString (int attributeType)
| Given an integer attribute type, this static method returns a string type for the attribute (i.e. More...
static const char * | GetLongAttributeTypeAsString (int attributeType)
| Given an integer attribute type, this static method returns a string type for the attribute (i.e. More...
Static Public Member Functions inherited from vtkFieldData
static vtkFieldData * | New ()
static vtkFieldData * | ExtendedNew ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFieldData * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDataSetAttributes ()
| ~vtkDataSetAttributes () override
void | InternalCopyAllocate (vtkDataSetAttributes *pd, int ctype, vtkIdType sze=0, vtkIdType ext=1000, int shallowCopyArrays=0, bool createNewArrays=true)
void | InitializeFields () override
| Initialize all of the object's data to nullptr. More...
Protected Member Functions inherited from vtkFieldData
| vtkFieldData ()
| ~vtkFieldData () override
void | SetArray (int i, vtkAbstractArray *array)
| Set an array to define the field. More...
void | CopyFieldOnOff (const char *name, int onOff)
void | ClearFieldFlags ()
int | FindFlag (const char *field)
int | GetFlag (const char *field)
void | CopyFlags (const vtkFieldData *source)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | AttributeIndices [NUM_ATTRIBUTES]
int | CopyAttributeFlags [ALLCOPY][NUM_ATTRIBUTES]
vtkFieldData::BasicIterator | RequiredArrays
int * | TargetIndices
Protected Attributes inherited from vtkFieldData
int | NumberOfArrays
int | NumberOfActiveArrays
vtkAbstractArray ** | Data
CopyFieldFlag * | CopyFieldFlags
int | NumberOfFieldFlags
int | DoCopyAllOn
int | DoCopyAllOff
unsigned char | GhostsToSkip
vtkUnsignedCharArray * | GhostArray
std::vector< std::array< CachedGhostRangeType, 2 > > | Ranges
| `Ranges` and `FiniteRanges` store cached ranges for arrays stored in this field data. More...
std::vector< std::array< CachedGhostRangeType, 2 > > | FiniteRanges
| `Ranges` and `FiniteRanges` store cached ranges for arrays stored in this field data. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static const int | NumberOfAttributeComponents [NUM_ATTRIBUTES]
static const int | AttributeLimits [NUM_ATTRIBUTES]
static const char | AttributeNames [NUM_ATTRIBUTES][19]
static const char | LongAttributeNames [NUM_ATTRIBUTES][42]

## Friends
struct | ArrayList
| List of possible ArrayTypes that are produced by vtkIOSSUtilities. More...
class | vtkDataSetAttributesFieldList

## Additional Inherited Members
Protected Types inherited from vtkFieldData
using | CachedGhostRangeType = std::tuple< vtkMTimeType, vtkMTimeType, std::vector< double > >
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

represent and manipulate attribute data in a dataset

vtkDataSetAttributes is a class that is used to represent and manipulate attribute data (e.g., scalars, vectors, normals, texture coordinates, tensors, global ids, pedigree ids, and field data).

This adds to vtkFieldData the ability to pick one of the arrays from the field as the currently active array for each attribute type. In other words, you pick one array to be called "THE" Scalars, and then filters down the pipeline will treat that array specially. For example vtkContourFilter will contour "THE" Scalar array unless a different array is asked for.

Additionally vtkDataSetAttributes provides methods that filters call to pass data through, copy data into, and interpolate from Fields. PassData passes entire arrays from the source to the destination. Copy passes through some subset of the tuples from the source to the destination. Interpolate interpolates from the chosen tuple(s) in the source data, using the provided weights, to produce new tuples in the destination. Each attribute type has pass, copy and interpolate "copy" flags that can be set in the destination to choose which attribute arrays will be transferred from the source to the destination.

Finally this class provides a mechanism to determine which attributes a group of sources have in common, and to copy tuples from a source into the destination, for only those attributes that are held by all.

Warning
  vtkDataSetAttributes is not in general thread safe due to the use of its vtkFieldData::BasicIterator RequiredArrays data member. The class vtkArrayListTemplate augments vtkDataSetAttributes for thread safety.

See also
  vtkArrayListTemplate

Examples:
  vtkDataSetAttributes (Examples)

Online Examples:

Tests:
  vtkDataSetAttributes (Tests)

Definition at line 64 of file vtkDataSetAttributes.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkFieldData vtkDataSetAttributes::Superclass

Definition at line 73 of file vtkDataSetAttributes.h.

## ◆ FieldList

using vtkDataSetAttributes::FieldList = vtkDataSetAttributesFieldList

Definition at line 630 of file vtkDataSetAttributes.h.

## Member Enumeration Documentation

## ◆ AttributeTypes

enum vtkDataSetAttributes::AttributeTypes

Enumerator
SCALARS |
VECTORS |
NORMALS |
TCOORDS |
TENSORS |
GLOBALIDS |
PEDIGREEIDS |
EDGEFLAG |
TANGENTS |
RATIONALWEIGHTS |
HIGHERORDERDEGREES |
PROCESSIDS |
NUM_ATTRIBUTES |

Definition at line 106 of file vtkDataSetAttributes.h.

## ◆ AttributeLimitTypes

enum vtkDataSetAttributes::AttributeLimitTypes

Enumerator
MAX |
EXACT |
NOLIMIT |

Definition at line 123 of file vtkDataSetAttributes.h.

## ◆ CellGhostTypes

enum vtkDataSetAttributes::CellGhostTypes

Enumerator
DUPLICATECELL |
HIGHCONNECTIVITYCELL |
LOWCONNECTIVITYCELL |
REFINEDCELL |
EXTERIORCELL |
HIDDENCELL |

Definition at line 134 of file vtkDataSetAttributes.h.

## ◆ PointGhostTypes

enum vtkDataSetAttributes::PointGhostTypes

Enumerator
DUPLICATEPOINT |
HIDDENPOINT |

Definition at line 145 of file vtkDataSetAttributes.h.

## ◆ AttributeCopyOperations

enum vtkDataSetAttributes::AttributeCopyOperations

Enumerator
COPYTUPLE |
INTERPOLATE |
PASSDATA |
ALLCOPY |

Definition at line 381 of file vtkDataSetAttributes.h.

## Constructor & Destructor Documentation

## ◆ vtkDataSetAttributes()

vtkDataSetAttributes::vtkDataSetAttributes | ( |  | ) |
| protected

## ◆ ~vtkDataSetAttributes()

vtkDataSetAttributes::~vtkDataSetAttributes | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkDataSetAttributes* vtkDataSetAttributes::New | ( |  | ) |
| static

Construct object with copying turned on for all data.

## ◆ ExtendedNew()

static vtkDataSetAttributes* vtkDataSetAttributes::ExtendedNew | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkDataSetAttributes::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDataSetAttributes::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkFieldData.

Reimplemented in vtkPointData, and vtkCellData.

## ◆ SafeDownCast()

static vtkDataSetAttributes* vtkDataSetAttributes::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDataSetAttributes::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkFieldData.

Reimplemented in vtkPointData, and vtkCellData.

## ◆ NewInstance()

vtkDataSetAttributes* vtkDataSetAttributes::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDataSetAttributes::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkPointData.

## ◆ Initialize()

void vtkDataSetAttributes::Initialize | ( |  | ) |
| overridevirtual

Initialize all of the object's data to nullptr Also, clear the copy flags.

Reimplemented from vtkFieldData.

## ◆ Update()

virtual void vtkDataSetAttributes::Update | ( |  | ) |
| inlinevirtual

Attributes have a chance to bring themselves up to date; right now this is ignored.

Definition at line 86 of file vtkDataSetAttributes.h.

## ◆ DeepCopy()

void vtkDataSetAttributes::DeepCopy | ( | vtkFieldData * | pd | ) |
| overridevirtual

Deep copy of data (i.e., create new data arrays and copy from input data).

Ignores the copy flags but preserves them in the output.

Reimplemented from vtkFieldData.

## ◆ ShallowCopy()

void vtkDataSetAttributes::ShallowCopy | ( | vtkFieldData * | pd | ) |
| overridevirtual

Shallow copy of data (i.e., use reference counting).

Ignores the copy flags but preserves them in the output.

Reimplemented from vtkFieldData.

## ◆ GhostArrayName()

static const char* vtkDataSetAttributes::GhostArrayName | ( |  | ) |
| inlinestatic

Definition at line 155 of file vtkDataSetAttributes.h.

## ◆ SetScalars()

int vtkDataSetAttributes::SetScalars | ( | vtkDataArray * | da | ) |

Set/Get the scalar data.

## ◆ SetActiveScalars()

int vtkDataSetAttributes::SetActiveScalars | ( | const char * | name | ) |

Set/Get the scalar data.

## ◆ GetScalars() [1/2]

vtkDataArray* vtkDataSetAttributes::GetScalars | ( |  | ) |

Set/Get the scalar data.

## ◆ SetVectors()

int vtkDataSetAttributes::SetVectors | ( | vtkDataArray * | da | ) |

Set/Get the vector data.

## ◆ SetActiveVectors()

int vtkDataSetAttributes::SetActiveVectors | ( | const char * | name | ) |

Set/Get the vector data.

## ◆ GetVectors() [1/2]

vtkDataArray* vtkDataSetAttributes::GetVectors | ( |  | ) |

Set/Get the vector data.

## ◆ SetNormals()

int vtkDataSetAttributes::SetNormals | ( | vtkDataArray * | da | ) |

Set/get the normal data.

## ◆ SetActiveNormals()

int vtkDataSetAttributes::SetActiveNormals | ( | const char * | name | ) |

Set/get the normal data.

## ◆ GetNormals() [1/2]

vtkDataArray* vtkDataSetAttributes::GetNormals | ( |  | ) |

Set/get the normal data.

## ◆ SetTangents()

int vtkDataSetAttributes::SetTangents | ( | vtkDataArray * | da | ) |

Set/get the tangent data.

## ◆ SetActiveTangents()

int vtkDataSetAttributes::SetActiveTangents | ( | const char * | name | ) |

Set/get the tangent data.

## ◆ GetTangents() [1/2]

vtkDataArray* vtkDataSetAttributes::GetTangents | ( |  | ) |

Set/get the tangent data.

## ◆ SetTCoords()

int vtkDataSetAttributes::SetTCoords | ( | vtkDataArray * | da | ) |

Set/Get the texture coordinate data.

## ◆ SetActiveTCoords()

int vtkDataSetAttributes::SetActiveTCoords | ( | const char * | name | ) |

Set/Get the texture coordinate data.

## ◆ GetTCoords() [1/2]

vtkDataArray* vtkDataSetAttributes::GetTCoords | ( |  | ) |

Set/Get the texture coordinate data.

## ◆ SetTensors()

int vtkDataSetAttributes::SetTensors | ( | vtkDataArray * | da | ) |

Set/Get the tensor data.

## ◆ SetActiveTensors()

int vtkDataSetAttributes::SetActiveTensors | ( | const char * | name | ) |

Set/Get the tensor data.

## ◆ GetTensors() [1/2]

vtkDataArray* vtkDataSetAttributes::GetTensors | ( |  | ) |

Set/Get the tensor data.

## ◆ SetGlobalIds()

int vtkDataSetAttributes::SetGlobalIds | ( | vtkDataArray * | da | ) |

Set/Get the global id data.

## ◆ SetActiveGlobalIds()

int vtkDataSetAttributes::SetActiveGlobalIds | ( | const char * | name | ) |

Set/Get the global id data.

## ◆ GetGlobalIds() [1/2]

vtkDataArray* vtkDataSetAttributes::GetGlobalIds | ( |  | ) |

Set/Get the global id data.

## ◆ SetPedigreeIds()

int vtkDataSetAttributes::SetPedigreeIds | ( | vtkAbstractArray * | da | ) |

Set/Get the pedigree id data.

## ◆ SetActivePedigreeIds()

int vtkDataSetAttributes::SetActivePedigreeIds | ( | const char * | name | ) |

Set/Get the pedigree id data.

## ◆ GetPedigreeIds() [1/2]

vtkAbstractArray* vtkDataSetAttributes::GetPedigreeIds | ( |  | ) |

Set/Get the pedigree id data.

## ◆ SetRationalWeights()

int vtkDataSetAttributes::SetRationalWeights | ( | vtkDataArray * | da | ) |

Set/Get the rational weights data.

## ◆ SetActiveRationalWeights()

int vtkDataSetAttributes::SetActiveRationalWeights | ( | const char * | name | ) |

Set/Get the rational weights data.

## ◆ GetRationalWeights() [1/2]

vtkDataArray* vtkDataSetAttributes::GetRationalWeights | ( |  | ) |

Set/Get the rational weights data.

## ◆ SetHigherOrderDegrees()

int vtkDataSetAttributes::SetHigherOrderDegrees | ( | vtkDataArray * | da | ) |

Set/Get the rational degrees data.

## ◆ SetActiveHigherOrderDegrees()

int vtkDataSetAttributes::SetActiveHigherOrderDegrees | ( | const char * | name | ) |

Set/Get the rational degrees data.

## ◆ GetHigherOrderDegrees() [1/2]

vtkDataArray* vtkDataSetAttributes::GetHigherOrderDegrees | ( |  | ) |

Set/Get the rational degrees data.

## ◆ SetProcessIds()

int vtkDataSetAttributes::SetProcessIds | ( | vtkDataArray * | da | ) |

Set/Get the process id data.

## ◆ SetActiveProcessIds()

int vtkDataSetAttributes::SetActiveProcessIds | ( | const char * | name | ) |

Set/Get the process id data.

## ◆ GetProcessIds() [1/2]

vtkDataArray* vtkDataSetAttributes::GetProcessIds | ( |  | ) |

Set/Get the process id data.

## ◆ GetScalars() [2/2]

vtkDataArray* vtkDataSetAttributes::GetScalars | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetVectors() [2/2]

vtkDataArray* vtkDataSetAttributes::GetVectors | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetNormals() [2/2]

vtkDataArray* vtkDataSetAttributes::GetNormals | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetTangents() [2/2]

vtkDataArray* vtkDataSetAttributes::GetTangents | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetTCoords() [2/2]

vtkDataArray* vtkDataSetAttributes::GetTCoords | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetTensors() [2/2]

vtkDataArray* vtkDataSetAttributes::GetTensors | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetGlobalIds() [2/2]

vtkDataArray* vtkDataSetAttributes::GetGlobalIds | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetPedigreeIds() [2/2]

vtkAbstractArray* vtkDataSetAttributes::GetPedigreeIds | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetRationalWeights() [2/2]

vtkDataArray* vtkDataSetAttributes::GetRationalWeights | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetHigherOrderDegrees() [2/2]

vtkDataArray* vtkDataSetAttributes::GetHigherOrderDegrees | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ GetProcessIds() [2/2]

vtkDataArray* vtkDataSetAttributes::GetProcessIds | ( | const char * | name | ) |

If the string is nullptr or empty, calls the alternate method of the same name (that takes no parameters).

Otherwise, it will look for an array with the correct name. If one exists, it is returned. Otherwise, nullptr is returned.

## ◆ SetActiveAttribute() [1/2]

int vtkDataSetAttributes::SetActiveAttribute | ( | const char * | name,
|  | int | attributeType
| ) |  |

Make the array with the given name the active attribute.

Attribute types are: vtkDataSetAttributes::SCALARS = 0 vtkDataSetAttributes::VECTORS = 1 vtkDataSetAttributes::NORMALS = 2 vtkDataSetAttributes::TCOORDS = 3 vtkDataSetAttributes::TENSORS = 4 vtkDataSetAttributes::GLOBALIDS = 5 vtkDataSetAttributes::PEDIGREEIDS = 6 vtkDataSetAttributes::EDGEFLAG = 7 vtkDataSetAttributes::TANGENTS = 8 vtkDataSetAttributes::RATIONALWEIGHTS = 9 vtkDataSetAttributes::HIGHERORDERDEGREES = 10 vtkDataSetAttributes::PROCESSIDS = 11 Returns the index of the array if successful, -1 if the array is not in the list of arrays.

## ◆ SetActiveAttribute() [2/2]

int vtkDataSetAttributes::SetActiveAttribute | ( | int | index,
|  | int | attributeType
| ) |  |

Make the array with the given index the active attribute.

Returns the index of the array if successful, -1 if the array is not in the list of arrays.

## ◆ GetAttributeIndices()

void vtkDataSetAttributes::GetAttributeIndices | ( | int * | indexArray | ) |

Get the field data array indices corresponding to scalars, vectors, tensors, etc.

The given buffer must be at least NUM_ATTRIBUTES elements big.

## ◆ IsArrayAnAttribute()

int vtkDataSetAttributes::IsArrayAnAttribute | ( | int | idx | ) |

Determine whether a data array of index idx is considered a data set attribute (i.e., scalar, vector, tensor, etc).

Return less-than zero if it is, otherwise an index 0<=idx<NUM_ATTRIBUTES to indicate which attribute.

## ◆ SetAttribute()

int vtkDataSetAttributes::SetAttribute | ( | vtkAbstractArray * | aa,
|  | int | attributeType
| ) |  |

Set an array to use as the given attribute type (i.e., vtkDataSetAttributes::SCALAR, vtkDataSetAttributes::VECTOR, vtkDataSetAttributes::TENSOR, etc.).

If this attribute was previously set to another array, that array is removed from the vtkDataSetAttributes object and the array aa is used as the attribute.

Returns the index of aa within the vtkDataSetAttributes object (i.e., the index to pass to the method GetArray(int) to obtain aa) if the attribute was set to aa successfully. If aa was already set as the given attributeType, returns the index of aa.

Returns -1 in the following cases:

- aa is nullptr (used to unset an attribute; not an error indicator)
- aa is not a subclass of vtkDataArray, unless the attributeType is vtkDataSetAttributes::PEDIGREEIDS (error indicator)
- aa has a number of components incompatible with the attribute type (error indicator)

## ◆ GetAttribute()

vtkDataArray* vtkDataSetAttributes::GetAttribute | ( | int | attributeType | ) |

Return an attribute given the attribute type (see vtkDataSetAttributes::AttributeTypes).

Some attributes (such as PEDIGREEIDS) may not be vtkDataArray subclass, so in that case use GetAbstractAttribute().

## ◆ GetAbstractAttribute()

vtkAbstractArray* vtkDataSetAttributes::GetAbstractAttribute | ( | int | attributeType | ) |

Return an attribute given the attribute type (see vtkDataSetAttributes::AttributeTypes).

This is the same as GetAttribute(), except that the returned array is a vtkAbstractArray instead of vtkDataArray. Some attributes (such as PEDIGREEIDS) may not be vtkDataArray subclass.

## ◆ RemoveArray() [1/3]

void vtkDataSetAttributes::RemoveArray | ( | int | index | ) |
| overridevirtual

Remove an array (with the given index) from the list of arrays.

Does nothing if the index is out of range.

Reimplemented from vtkFieldData.

## ◆ GetAttributeTypeAsString()

static const char* vtkDataSetAttributes::GetAttributeTypeAsString | ( | int | attributeType | ) |
| static

Given an integer attribute type, this static method returns a string type for the attribute (i.e.

type = 0: returns "Scalars").

## ◆ GetLongAttributeTypeAsString()

static const char* vtkDataSetAttributes::GetLongAttributeTypeAsString | ( | int | attributeType | ) |
| static

Given an integer attribute type, this static method returns a string type for the attribute (i.e.

type = 0: returns "Scalars").

## ◆ SetCopyAttribute()

void vtkDataSetAttributes::SetCopyAttribute | ( | int | index,
|  | int | value,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyAttribute()

int vtkDataSetAttributes::GetCopyAttribute | ( | int | index,
|  | int | ctype
| ) |  |

Get the attribute copy flag for copy operation `ctype` of attribute `index`.

## ◆ SetCopyScalars()

void vtkDataSetAttributes::SetCopyScalars | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyScalars()

vtkTypeBool vtkDataSetAttributes::GetCopyScalars | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyScalarsOn()

virtual void vtkDataSetAttributes::CopyScalarsOn | ( |  | ) |
| virtual

## ◆ CopyScalarsOff()

virtual void vtkDataSetAttributes::CopyScalarsOff | ( |  | ) |
| virtual

## ◆ SetCopyVectors()

void vtkDataSetAttributes::SetCopyVectors | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyVectors()

vtkTypeBool vtkDataSetAttributes::GetCopyVectors | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyVectorsOn()

virtual void vtkDataSetAttributes::CopyVectorsOn | ( |  | ) |
| virtual

## ◆ CopyVectorsOff()

virtual void vtkDataSetAttributes::CopyVectorsOff | ( |  | ) |
| virtual

## ◆ SetCopyNormals()

void vtkDataSetAttributes::SetCopyNormals | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyNormals()

vtkTypeBool vtkDataSetAttributes::GetCopyNormals | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyNormalsOn()

virtual void vtkDataSetAttributes::CopyNormalsOn | ( |  | ) |
| virtual

## ◆ CopyNormalsOff()

virtual void vtkDataSetAttributes::CopyNormalsOff | ( |  | ) |
| virtual

## ◆ SetCopyTangents()

void vtkDataSetAttributes::SetCopyTangents | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyTangents()

vtkTypeBool vtkDataSetAttributes::GetCopyTangents | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyTangentsOn()

virtual void vtkDataSetAttributes::CopyTangentsOn | ( |  | ) |
| virtual

## ◆ CopyTangentsOff()

virtual void vtkDataSetAttributes::CopyTangentsOff | ( |  | ) |
| virtual

## ◆ SetCopyTCoords()

void vtkDataSetAttributes::SetCopyTCoords | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyTCoords()

vtkTypeBool vtkDataSetAttributes::GetCopyTCoords | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyTCoordsOn()

virtual void vtkDataSetAttributes::CopyTCoordsOn | ( |  | ) |
| virtual

## ◆ CopyTCoordsOff()

virtual void vtkDataSetAttributes::CopyTCoordsOff | ( |  | ) |
| virtual

## ◆ SetCopyTensors()

void vtkDataSetAttributes::SetCopyTensors | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyTensors()

vtkTypeBool vtkDataSetAttributes::GetCopyTensors | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyTensorsOn()

virtual void vtkDataSetAttributes::CopyTensorsOn | ( |  | ) |
| virtual

## ◆ CopyTensorsOff()

virtual void vtkDataSetAttributes::CopyTensorsOff | ( |  | ) |
| virtual

## ◆ SetCopyGlobalIds()

void vtkDataSetAttributes::SetCopyGlobalIds | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyGlobalIds()

vtkTypeBool vtkDataSetAttributes::GetCopyGlobalIds | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyGlobalIdsOn()

virtual void vtkDataSetAttributes::CopyGlobalIdsOn | ( |  | ) |
| virtual

## ◆ CopyGlobalIdsOff()

virtual void vtkDataSetAttributes::CopyGlobalIdsOff | ( |  | ) |
| virtual

## ◆ SetCopyPedigreeIds()

void vtkDataSetAttributes::SetCopyPedigreeIds | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyPedigreeIds()

vtkTypeBool vtkDataSetAttributes::GetCopyPedigreeIds | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyPedigreeIdsOn()

virtual void vtkDataSetAttributes::CopyPedigreeIdsOn | ( |  | ) |
| virtual

## ◆ CopyPedigreeIdsOff()

virtual void vtkDataSetAttributes::CopyPedigreeIdsOff | ( |  | ) |
| virtual

## ◆ SetCopyRationalWeights()

void vtkDataSetAttributes::SetCopyRationalWeights | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyRationalWeights()

vtkTypeBool vtkDataSetAttributes::GetCopyRationalWeights | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyRationalWeightsOn()

virtual void vtkDataSetAttributes::CopyRationalWeightsOn | ( |  | ) |
| virtual

## ◆ CopyRationalWeightsOff()

virtual void vtkDataSetAttributes::CopyRationalWeightsOff | ( |  | ) |
| virtual

## ◆ SetCopyHigherOrderDegrees()

void vtkDataSetAttributes::SetCopyHigherOrderDegrees | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyHigherOrderDegrees()

vtkTypeBool vtkDataSetAttributes::GetCopyHigherOrderDegrees | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyHigherOrderDegreesOn()

virtual void vtkDataSetAttributes::CopyHigherOrderDegreesOn | ( |  | ) |
| virtual

## ◆ CopyHigherOrderDegreesOff()

virtual void vtkDataSetAttributes::CopyHigherOrderDegreesOff | ( |  | ) |
| virtual

## ◆ SetCopyProcessIds()

void vtkDataSetAttributes::SetCopyProcessIds | ( | vtkTypeBool | i,
|  | int | ctype = `ALLCOPY`
| ) |  |

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

## ◆ GetCopyProcessIds()

vtkTypeBool vtkDataSetAttributes::GetCopyProcessIds | ( | int | ctype = `ALLCOPY` | ) |

## ◆ CopyProcessIdsOn()

virtual void vtkDataSetAttributes::CopyProcessIdsOn | ( |  | ) |
| virtual

## ◆ CopyProcessIdsOff()

virtual void vtkDataSetAttributes::CopyProcessIdsOff | ( |  | ) |
| virtual

## ◆ CopyAllOn()

void vtkDataSetAttributes::CopyAllOn | ( | int | ctype = `ALLCOPY` | ) |
| overridevirtual

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

Reimplemented from vtkFieldData.

## ◆ CopyAllOff()

void vtkDataSetAttributes::CopyAllOff | ( | int | ctype = `ALLCOPY` | ) |
| overridevirtual

Turn on/off the copying of attribute data.

ctype is one of the AttributeCopyOperations, and controls copy, interpolate and passdata behavior. For set, ctype=ALLCOPY means set all three flags to the same value. For get, ctype=ALLCOPY returns true only if all three flags are true.

During copying, interpolation and passdata, the following rules are followed for each array:

1. If the copy/interpolate/pass flag for an attribute is set (on or off), it is applied. This overrides rules 2 and 3.
2. If the copy flag for an array is set (on or off), it is applied This overrides rule 3.
3. If CopyAllOn is set, copy the array. If CopyAllOff is set, do not copy the array

For interpolation, the flag values can be as follows: 0: Do not interpolate. 1: Weighted interpolation. 2: Nearest neighbor interpolation.

Reimplemented from vtkFieldData.

## ◆ PassData()

void vtkDataSetAttributes::PassData | ( | vtkFieldData * | fd | ) |
| overridevirtual

Pass entire arrays of input data through to output.

Obey the "copy" flags. When passing a field, the following copying rules are followed: 1) Check if a field is an attribute, if yes and if there is a PASSDATA copy flag for that attribute (on or off), obey the flag for that attribute, ignore (2) and (3), 2) if there is a copy field for that field (on or off), obey the flag, ignore (3) 3) obey CopyAllOn/Off

Reimplemented from vtkFieldData.

## ◆ CopyAllocate() [1/3]

void vtkDataSetAttributes::CopyAllocate | ( | vtkDataSetAttributes * | pd,
|  | vtkIdType | sze = `0`,
|  | vtkIdType | ext = `1000`
| ) |  |
| inline

Allocates point data for point-by-point (or cell-by-cell) copy operation.

If sze=0, then use the input DataSetAttributes to create (i.e., find initial size of) new objects; otherwise use the sze variable. Note that pd HAS to be the vtkDataSetAttributes object which will later be used with CopyData. If this is not the case, consider using the alternative forms of CopyAllocate and CopyData. ext is no longer used. If shallowCopyArrays is true, input arrays are copied to the output instead of new ones being allocated.

Definition at line 506 of file vtkDataSetAttributes.h.

## ◆ CopyAllocate() [2/3]

void vtkDataSetAttributes::CopyAllocate | ( | vtkDataSetAttributes * | pd,
|  | vtkIdType | sze,
|  | vtkIdType | ext,
|  | int | shallowCopyArrays
| ) |  |

Allocates point data for point-by-point (or cell-by-cell) copy operation.

If sze=0, then use the input DataSetAttributes to create (i.e., find initial size of) new objects; otherwise use the sze variable. Note that pd HAS to be the vtkDataSetAttributes object which will later be used with CopyData. If this is not the case, consider using the alternative forms of CopyAllocate and CopyData. ext is no longer used. If shallowCopyArrays is true, input arrays are copied to the output instead of new ones being allocated.

## ◆ SetupForCopy()

void vtkDataSetAttributes::SetupForCopy | ( | vtkDataSetAttributes * | pd | ) |

Create a mapping between the input attributes and this object so that methods like CopyData() and CopyStructuredData() can be called.

This method assumes that this object has the same arrays as the input and that they are ordered the same way (same array indices).

## ◆ CopyStructuredData()

void vtkDataSetAttributes::CopyStructuredData | ( | vtkDataSetAttributes * | inDsa,
|  | const int * | inExt,
|  | const int * | outExt,
|  | bool | setSize = `true`
| ) |  |

This method is used to copy data arrays in images.

You should call CopyAllocate or SetupForCopy before calling this method. If setSize is true, this method will set the size of the output arrays according to the output extent. This is required when CopyAllocate() was used to setup output arrays.

## ◆ CopyData() [1/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdType | fromId,
|  | vtkIdType | toId
| ) |  |

Copy the attribute data from one id to another.

Make sure CopyAllocate() has been invoked before using this method. When copying a field, the following copying rules are followed: 1) Check if a field is an attribute, if yes and if there is a COPYTUPLE copy flag for that attribute (on or off), obey the flag for that attribute, ignore (2) and (3), 2) if there is a copy field for that field (on or off), obey the flag, ignore (3) 3) obey CopyAllOn/Off

Warning
  This method is prone to compile-time ambiguity when called using `0` parameters. To fix the ambiguity, please replace `0` by `vtkIdType(0)`.

## ◆ CopyData() [2/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdList * | fromIds,
|  | vtkIdList * | toIds
| ) |  |

Copy the attribute data from one id to another.

Make sure CopyAllocate() has been invoked before using this method. When copying a field, the following copying rules are followed: 1) Check if a field is an attribute, if yes and if there is a COPYTUPLE copy flag for that attribute (on or off), obey the flag for that attribute, ignore (2) and (3), 2) if there is a copy field for that field (on or off), obey the flag, ignore (3) 3) obey CopyAllOn/Off

Warning
  This method is prone to compile-time ambiguity when called using `0` parameters. To fix the ambiguity, please replace `0` by `vtkIdType(0)`.

## ◆ CopyData() [3/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdList * | fromIds,
|  | vtkIdType | destStartId = `0`
| ) |  |

Copy the attribute data from one id to another.

Make sure CopyAllocate() has been invoked before using this method. When copying a field, the following copying rules are followed: 1) Check if a field is an attribute, if yes and if there is a COPYTUPLE copy flag for that attribute (on or off), obey the flag for that attribute, ignore (2) and (3), 2) if there is a copy field for that field (on or off), obey the flag, ignore (3) 3) obey CopyAllOn/Off

Warning
  This method is prone to compile-time ambiguity when called using `0` parameters. To fix the ambiguity, please replace `0` by `vtkIdType(0)`.

## ◆ CopyData() [4/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdType | dstStart,
|  | vtkIdType | n,
|  | vtkIdType | srcStart
| ) |  |

Copy n consecutive attributes starting at srcStart from fromPd to this container, starting at the dstStart location.

Note that memory allocation is performed as necessary to hold the data.

## ◆ CopyTuple()

void vtkDataSetAttributes::CopyTuple | ( | vtkAbstractArray * | fromData,
|  | vtkAbstractArray * | toData,
|  | vtkIdType | fromId,
|  | vtkIdType | toId
| ) |  |

Copy a tuple (or set of tuples) of data from one data array to another.

This method assumes that the fromData and toData objects are of the same type, and have the same number of components. This is true if you invoke CopyAllocate() or InterpolateAllocate().

## ◆ CopyTuples() [1/2]

void vtkDataSetAttributes::CopyTuples | ( | vtkAbstractArray * | fromData,
|  | vtkAbstractArray * | toData,
|  | vtkIdList * | fromIds,
|  | vtkIdList * | toIds
| ) |  |

Copy a tuple (or set of tuples) of data from one data array to another.

This method assumes that the fromData and toData objects are of the same type, and have the same number of components. This is true if you invoke CopyAllocate() or InterpolateAllocate().

## ◆ CopyTuples() [2/2]

void vtkDataSetAttributes::CopyTuples | ( | vtkAbstractArray * | fromData,
|  | vtkAbstractArray * | toData,
|  | vtkIdType | dstStart,
|  | vtkIdType | n,
|  | vtkIdType | srcStart
| ) |  |

Copy a tuple (or set of tuples) of data from one data array to another.

This method assumes that the fromData and toData objects are of the same type, and have the same number of components. This is true if you invoke CopyAllocate() or InterpolateAllocate().

## ◆ InterpolateAllocate() [1/3]

void vtkDataSetAttributes::InterpolateAllocate | ( | vtkDataSetAttributes * | pd,
|  | vtkIdType | sze = `0`,
|  | vtkIdType | ext = `1000`
| ) |  |
| inline

Initialize point interpolation method.

Note that pd HAS to be the vtkDataSetAttributes object which will later be used with InterpolatePoint or InterpolateEdge. ext is no longer used. If shallowCopyArrays is true, input arrays are copied to the output instead of new ones being allocated.

Definition at line 585 of file vtkDataSetAttributes.h.

## ◆ InterpolateAllocate() [2/3]

void vtkDataSetAttributes::InterpolateAllocate | ( | vtkDataSetAttributes * | pd,
|  | vtkIdType | sze,
|  | vtkIdType | ext,
|  | int | shallowCopyArrays
| ) |  |

Initialize point interpolation method.

Note that pd HAS to be the vtkDataSetAttributes object which will later be used with InterpolatePoint or InterpolateEdge. ext is no longer used. If shallowCopyArrays is true, input arrays are copied to the output instead of new ones being allocated.

## ◆ InterpolatePoint() [1/2]

void vtkDataSetAttributes::InterpolatePoint | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdType | toId,
|  | vtkIdList * | ids,
|  | double * | weights
| ) |  |

Interpolate data set attributes from other data set attributes given cell or point ids and associated interpolation weights.

If the INTERPOLATION copy flag is set to 0 for an array, interpolation is prevented. If the flag is set to 1, weighted interpolation occurs. If the flag is set to 2, nearest neighbor interpolation is used.

## ◆ InterpolateEdge()

void vtkDataSetAttributes::InterpolateEdge | ( | vtkDataSetAttributes * | fromPd,
|  | vtkIdType | toId,
|  | vtkIdType | p1,
|  | vtkIdType | p2,
|  | double | t
| ) |  |

Interpolate data from the two points p1,p2 (forming an edge) and an interpolation factor, t, along the edge.

The weight ranges from (0,1), with t=0 located at p1. Make sure that the method InterpolateAllocate() has been invoked before using this method. If the INTERPOLATION copy flag is set to 0 for an array, interpolation is prevented. If the flag is set to 1, weighted interpolation occurs. If the flag is set to 2, nearest neighbor interpolation is used.

## ◆ InterpolateTime()

void vtkDataSetAttributes::InterpolateTime | ( | vtkDataSetAttributes * | from1,
|  | vtkDataSetAttributes * | from2,
|  | vtkIdType | id,
|  | double | t
| ) |  |

Interpolate data from the same id (point or cell) at different points in time (parameter t).

Two input data set attributes objects are input. The parameter t lies between (0<=t<=1). IMPORTANT: it is assumed that the number of attributes and number of components is the same for both from1 and from2, and the type of data for from1 and from2 are the same. Make sure that the method InterpolateAllocate() has been invoked before using this method. If the INTERPOLATION copy flag is set to 0 for an array, interpolation is prevented. If the flag is set to 1, weighted interpolation occurs. If the flag is set to 2, nearest neighbor interpolation is used.

## ◆ CopyAllocate() [3/3]

void vtkDataSetAttributes::CopyAllocate | ( | vtkDataSetAttributes::FieldList & | list,
|  | vtkIdType | sze = `0`,
|  | vtkIdType | ext = `1000`
| ) |  |

A special form of CopyAllocate() to be used with FieldLists.

Use it when you are copying data from a set of vtkDataSetAttributes.

## ◆ CopyData() [5/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes::FieldList & | list,
|  | vtkDataSetAttributes * | dsa,
|  | int | idx,
|  | vtkIdType | fromId,
|  | vtkIdType | toId
| ) |  |

Special forms of CopyData() to be used with FieldLists.

Use it when you are copying data from a set of vtkDataSetAttributes. Make sure that you have called the special form of CopyAllocate that accepts FieldLists.

## ◆ CopyData() [6/6]

void vtkDataSetAttributes::CopyData | ( | vtkDataSetAttributes::FieldList & | list,
|  | vtkDataSetAttributes * | dsa,
|  | int | idx,
|  | vtkIdType | dstStart,
|  | vtkIdType | n,
|  | vtkIdType | srcStart
| ) |  |

## ◆ InterpolateAllocate() [3/3]

void vtkDataSetAttributes::InterpolateAllocate | ( | vtkDataSetAttributes::FieldList & | list,
|  | vtkIdType | sze = `0`,
|  | vtkIdType | ext = `1000`
| ) |  |

A special form of InterpolateAllocate() to be used with FieldLists.

Use it when you are interpolating data from a set of vtkDataSetAttributes. `Warning:` This does not copy the Information object associated with each data array. This behavior may change in the future.

## ◆ InterpolatePoint() [2/2]

void vtkDataSetAttributes::InterpolatePoint | ( | vtkDataSetAttributes::FieldList & | list,
|  | vtkDataSetAttributes * | fromPd,
|  | int | idx,
|  | vtkIdType | toId,
|  | vtkIdList * | ids,
|  | double * | weights
| ) |  |

Interpolate data set attributes from other data set attributes given cell or point ids and associated interpolation weights.

Make sure that special form of InterpolateAllocate() that accepts FieldList has been used.

## ◆ InternalCopyAllocate()

void vtkDataSetAttributes::InternalCopyAllocate | ( | vtkDataSetAttributes * | pd,
|  | int | ctype,
|  | vtkIdType | sze = `0`,
|  | vtkIdType | ext = `1000`,
|  | int | shallowCopyArrays = `0`,
|  | bool | createNewArrays = `true`
| ) |  |
| protected

## ◆ InitializeFields()

void vtkDataSetAttributes::InitializeFields | ( |  | ) |
| overrideprotectedvirtual

Initialize all of the object's data to nullptr.

Reimplemented from vtkFieldData.

## ◆ RemoveArray() [2/3]

virtual void vtkFieldData::RemoveArray

Remove an array (with the given index) from the list of arrays.

Does nothing if the index is out of range.

## ◆ RemoveArray() [3/3]

virtual void vtkFieldData::RemoveArray

Remove an array (with the given index) from the list of arrays.

Does nothing if the index is out of range.

## Friends And Related Function Documentation

## ◆ ArrayList

friend struct ArrayList
| friend

List of possible ArrayTypes that are produced by vtkIOSSUtilities.

This can be used with vtkArrayDispatch::DispatchByArray, etc. when dealing with arrays read from Ioss.

Definition at line 684 of file vtkDataSetAttributes.h.

## ◆ vtkDataSetAttributesFieldList

friend class vtkDataSetAttributesFieldList
| friend

Definition at line 701 of file vtkDataSetAttributes.h.

## Member Data Documentation

## ◆ AttributeIndices

int vtkDataSetAttributes::AttributeIndices[NUM_ATTRIBUTES]
| protected

Definition at line 681 of file vtkDataSetAttributes.h.

## ◆ CopyAttributeFlags

int vtkDataSetAttributes::CopyAttributeFlags[ALLCOPY][NUM_ATTRIBUTES]
| protected

Definition at line 682 of file vtkDataSetAttributes.h.

## ◆ RequiredArrays

vtkFieldData::BasicIterator vtkDataSetAttributes::RequiredArrays
| protected

Definition at line 685 of file vtkDataSetAttributes.h.

## ◆ TargetIndices

int* vtkDataSetAttributes::TargetIndices
| protected

Definition at line 686 of file vtkDataSetAttributes.h.

## ◆ NumberOfAttributeComponents

const int vtkDataSetAttributes::NumberOfAttributeComponents[NUM_ATTRIBUTES]
| staticprotected

Definition at line 688 of file vtkDataSetAttributes.h.

## ◆ AttributeLimits

const int vtkDataSetAttributes::AttributeLimits[NUM_ATTRIBUTES]
| staticprotected

Definition at line 689 of file vtkDataSetAttributes.h.

## ◆ AttributeNames

const char vtkDataSetAttributes::AttributeNames[NUM_ATTRIBUTES][19]
| staticprotected

Definition at line 690 of file vtkDataSetAttributes.h.

## ◆ LongAttributeNames

const char vtkDataSetAttributes::LongAttributeNames[NUM_ATTRIBUTES][42]
| staticprotected

Definition at line 691 of file vtkDataSetAttributes.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkDataSetAttributes.h